﻿Public Class Form1

    Dim minhaPalavra As String ' A palavra que será adivinhada
    Dim tamanhoPalavra As Integer
    Dim letraUsada As String
    Dim numeroLetrasCorretas As Integer
    Dim numeroLetrasIncorretas As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSair.Click
        Application.Exit()
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If rdoSomLigado.Checked = True Then
            My.Computer.Audio.Play(My.Resources.programexit, AudioPlayMode.Background)
        End If
        If MsgBox("Deseja realmente sair ?", vbYesNo + vbQuestion, "Fechar") = vbNo Then
            e.Cancel = True
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' Toca o arquivo de áudio na introdução
        My.Computer.Audio.Play(My.Resources.opening, AudioPlayMode.Background)

        ' Desabilita todas as letras dos botões e labels
        DesabilitaBotoes()
        DesabilitaLabels()

        ' Define o no de jogadores para um
        rdoUmJogador.Checked = True

        ' LIga o som
        rdoSomLigado.Checked = True

        ' Define as imagens de fundo
        DefineImagens()

    End Sub

    Sub DefineImagens()
        ' Define a imagem para a forca vazia
        picBox.Image = My.Resources.gallows
    End Sub

    Sub DesabilitaBotoes()
        Dim ctrl As Control
        For Each ctrl In groupLetters.Controls
            If TypeOf ctrl Is Button Then
                ctrl.Visible = False
            End If
        Next
    End Sub

    Sub DesabilitaLabels()
        Dim lbls As Control
        For Each lbls In groupPalavra.Controls
            If TypeOf lbls Is Label Then
                lbls.Visible = False
            End If
        Next
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNovoJogo.Click
        numeroLetrasIncorretas = 0  ' Novo jogo
        numeroLetrasCorretas = 0    ' NovoJogo

        ' Um ou dois jogadores ?
        ' Se for dois pergunta a palavra e verifica
        If rdoDoisJogadores.Checked = True Then
            minhaPalavra = UCase(InputBox("Informe uma palavra entre 1 e 15 letras."))
            ' Remove os espaços
            minhaPalavra = minhaPalavra.Replace(" ", "")
            numeroLetrasCorretas = 0
            numeroLetrasIncorretas = 0
            tamanhoPalavra = Len(minhaPalavra)
            If tamanhoPalavra < 1 Or tamanhoPalavra > 15 Then
                MsgBox("Tente novamente com uma palavra de até 15 letras.")
                NovoJogo()
                Exit Sub
            Else

                If minhaPalavra.Count <> minhaPalavra.Count(Function(C) Char.IsLetter(C)) Then
                    MsgBox("A palavra deve conter somente letras , sem espaços ou caracteres especiais.")
                    NovoJogo()
                    Exit Sub
                End If
            End If
        Else

            Dim appPath As String = Application.StartupPath()
            If My.Computer.FileSystem.FileExists(appPath & "\palavras.txt") Then
                ' Le o texto no textbox
                Dim leitor As String
                leitor = My.Computer.FileSystem.ReadAllText(appPath & "\palavras.txt")
                TextBox1.Text = leitor
                Dim RandomNumber As New Random
                Dim GetWord As Integer
                GetWord = RandomNumber.Next(TextBox1.Lines.Length)
                minhaPalavra = TextBox1.Lines(GetWord)
            Else
                MsgBox("Error - Não existem palavras para escolher. Será definida uma palavra inicial...")
                'Exit Sub
            End If

            ' se não tiver palavras
            If minhaPalavra = "" Then
                minhaPalavra = "ENFORCADO"
            End If


            minhaPalavra = UCase(minhaPalavra)
            minhaPalavra = minhaPalavra.Replace(" ", "")
            numeroLetrasCorretas = 0
            numeroLetrasIncorretas = 0
            tamanhoPalavra = Len(minhaPalavra)

            '  Define configurações do novo jogo
            NovoJogo()
        End If
        ' Uma noava palavra foi entrada ou selecionada, desabilita as labels e ativa a quantidade de letras
        DesabilitaLabels()
        For i As Integer = 0 To tamanhoPalavra - 1
            ' Lembre-se , arrays começcam com indice zero então, L(0)=L1, L(1)=L2, etc.
            MinhaLabel(i).Visible = True
        Next
        ' Habilita os botões
        Dim ctrl As Control
        For Each ctrl In groupLetters.Controls
            If TypeOf ctrl Is Button Then
                ctrl.Visible = True
            End If
        Next
    End Sub
    Sub NovoJogo()
        DesabilitaBotoes()
        DesabilitaLabels()
        lblNumeroErros.Text = "6"
        numeroLetrasCorretas = 0
        numeroLetrasIncorretas = 0
        ' Define todas as letras como vazias
        Dim blank As Integer
        For blank = 1 To 15
            MinhaLabel(blank - 1).Text = ""
        Next
        lblNumeroErros.ForeColor = Color.Green
        DefineImagens()
    End Sub

    Private Sub btnAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSobre.Click
        MsgBox("VB - Jogo da Forca" & vbCrLf & "adaptado por Macoratti .net" & vbCrLf & vbCrLf & "Um jogo para se divertir e aprender a usar recurso " & vbCrLf & "do Visual Basic.")
    End Sub


    Private Sub ButtonClicks(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonA.Click, ButtonB.Click, ButtonC.Click, ButtonD.Click, ButtonE.Click, _
        ButtonF.Click, ButtonG.Click, ButtonH.Click, ButtonI.Click, ButtonJ.Click, ButtonK.Click, ButtonL.Click, ButtonM.Click, ButtonN.Click, ButtonO.Click, ButtonP.Click, _
        ButtonQ.Click, ButtonR.Click, ButtonS.Click, ButtonT.Click, ButtonU.Click, ButtonV.Click, ButtonW.Click, ButtonX.Click, ButtonY.Click, ButtonZ.Click

        Dim strText As String = DirectCast(sender, Button).Text
        Select Case strText
            Case "A"
                ButtonA.Visible = False
            Case "B"
                ButtonB.Visible = False
            Case "C"
                ButtonC.Visible = False
            Case "D"
                ButtonD.Visible = False
            Case "E"
                ButtonE.Visible = False
            Case "F"
                ButtonF.Visible = False
            Case "G"
                ButtonG.Visible = False
            Case "H"
                ButtonH.Visible = False
            Case "I"
                ButtonI.Visible = False
            Case "J"
                ButtonJ.Visible = False
            Case "K"
                ButtonK.Visible = False
            Case "L"
                ButtonA.Visible = False
            Case "M"
                ButtonM.Visible = False
            Case "N"
                ButtonN.Visible = False
            Case "O"
                ButtonO.Visible = False
            Case "P"
                ButtonP.Visible = False
            Case "Q"
                ButtonQ.Visible = False
            Case "R"
                ButtonR.Visible = False
            Case "S"
                ButtonS.Visible = False
            Case "T"
                ButtonT.Visible = False
            Case "U"
                ButtonU.Visible = False
            Case "V"
                ButtonV.Visible = False
            Case "W"
                ButtonW.Visible = False
            Case "X"
                ButtonX.Visible = False
            Case "Y"
                ButtonY.Visible = False
            Case "Z"
                ButtonZ.Visible = False
        End Select
        letraUsada = strText
        SearchWord()
    End Sub

    Sub SearchWord()
        Dim searching As Integer = 1
        For searching = 1 To Len(minhaPalavra)
            If Mid(minhaPalavra, searching, Len(letraUsada)) = letraUsada Then
                MinhaLabel(searching - 1).Text = letraUsada
                numeroLetrasCorretas += 1
                If rdoSomLigado.Checked = True Then
                    My.Computer.Audio.Play(My.Resources.ding, AudioPlayMode.Background)
                End If
            End If
        Next
        ' se a letra não estiver na palavra
        If Not minhaPalavra.Contains(letraUsada) Then
            numeroLetrasIncorretas += 1
            lblNumeroErros.Text = 6 - numeroLetrasIncorretas
            If lblNumeroErros.Text = "5" Or lblNumeroErros.Text = "6" Then
                lblNumeroErros.ForeColor = Color.Green
            ElseIf lblNumeroErros.Text = "4" Or lblNumeroErros.Text = "3" Then
                lblNumeroErros.ForeColor = Color.Goldenrod
            Else
                lblNumeroErros.ForeColor = Color.Red
            End If

            If rdoSomLigado.Checked = True Then
                My.Computer.Audio.Play(My.Resources.doh, AudioPlayMode.Background)
            End If
            GetImagem()
            If numeroLetrasIncorretas = 6 Then FimDeJogo()
        End If
        If numeroLetrasCorretas = Len(minhaPalavra) Then
            UsuarioGanhou()
        End If

    End Sub

    Sub FimDeJogo()
        ' Informa ao jogoador que ele perdeu
        If rdoSomLigado.Checked = True Then
            My.Computer.Audio.Play(My.Resources.loser, AudioPlayMode.Background)
        End If

        MsgBox("Você enforcou o pobre homem. A palavra era : " & minhaPalavra)
        NovoJogo()
    End Sub

    Sub UsuarioGanhou()
        ' Informa ao jogador que ele ganhou
        If rdoSomLigado.Checked = True Then
            My.Computer.Audio.Play(My.Resources.winner, AudioPlayMode.Background)
        End If
        MsgBox("Você salvou o homem da Forca, Parabéns!" & vbCrLf & "A palavra era : " & minhaPalavra)
        NovoJogo()
    End Sub

    Sub GetImagem()
        ' Exibe a imagem apropriada dependendo de quantos adivinhações erradas
        Dim int As Integer = numeroLetrasIncorretas
        Select Case int
            Case 1
                picBox.Image = My.Resources.gallows1
            Case 2
                picBox.Image = My.Resources.gallows2
            Case 3
                picBox.Image = My.Resources.gallows3
            Case 4
                picBox.Image = My.Resources.gallows4
            Case 5
                picBox.Image = My.Resources.gallows5
            Case 6
                picBox.Image = My.Resources.gallows5
        End Select
    End Sub

End Class
